.PH ""
.nf
                                      John Schmidt
                                      September 14, 1987
.SP
.ce
R & D Quality Report -- Pascal Workstation 3.2
.fi
.SP
This report uses the FURPS model to describe the quality of the
Pascal 3.2 release. The FURPS parameters are: Functionality, Usability,
Reliability, Performance, and Supportability.
.SP
.H 1 "FUNCTIONALITY"
The functionality of the Pascal Workstation System (PWS) has been 
significantly enhanced in the 3.2 revision. Support for the HFS file
system has been added, giving the user the option of having PWS and
HP-UX co-reside on the same disc, thus allowing access to HP-UX tools
and networking facilities. Files can easily be shared between the two
operating systems. The HFS file system is also a great benefit to the
user who does not use HP-UX, as it provides a means for reasonably
organizing data on large local discs.
.SP
The BACKUP utility provides a means of exchanging data with HP-UX
systems (and other BASIC 5.0 or PWS 3.2 users) using cpio format
tapes and floppy discs. This utility permits selective backup of
all supported file systems, a capability which users have requested
for some time.
.SP
In addition, a new driver, DGL_REL, has been added to the graphics
(DGL) library. This driver permits much better response when using the
mouse or trackball as a graphics input device. This enhancement was
a result of requests from several PWS users.
.SP
Finally, the 3.2 release officially supports the 330 and 350 processors.
This permits the PWS user to keep up with HP's latest SPU technology.
.H 1 "USABILITY"
Overall usability of the PWS has not changed from previous releases. We
have taken care to ensure that almost all user code which was compiled
on Pascal 3.0 or 3.1 will run with no problems under the 3.2 release. 
The only exceptions to this would be programs which contain linked-in
versions of system code which was modfied for 3.2.  
.SP
The HFS file system enhancements have resulted in several changes to
utilities such as the FILER, and additional utilities have been provided
for HFS file system maintenance. We have attempted to maintain the "feel"
of the PWS in these enhancements. In some instances, we have also used
human interfaces similar to the HP-UX versions of the tools (such as
with HFSCK), to try to minimize the number of different "faces" seen
by the user.
.H 1 "RELIABILITY"
The 3.2 release has met most of the goals specified in its QA plan, as
listed below:
.AL
.LI
All test suites have been run with satisfactory results.
.LI
All must items in QA plans (and most "wants") have been completed. 
In addition, the HFS file system and its utilities have been tested
extensively beyond the items specified in the original QA plans.
.LI
Review of manuals has been completed.
.LI
All DTS reports have been resolved, and all defects of weight 4 or more
have been repaired, with one exception (detailed below).
.LI
We had a goal of no weight 4 or more defects in the last 2 weeks of QA.
One weight 7 defect was found. This defect could result in corruption
of an HFS file system if the user were to user some fairly unlikely
combinations of parameters in building a file system with the MKHFS
utility. After discussion with the R & D team and Doug Howell (QA dept.),
we decided that the appropriate corrective action would be to include
a manual update in the product which would warn the user not to change
the default file system parameters. This defect will be repaired in the
next revision of the system.
.LI
All STARS reports known at the time of bit release have been reviewed.
All critical and serious defects have been fixed. Some lower weight
defects have been deferred for future releases, or will be resolved
by supplying workarounds.
.LI
The weighted defects/1000 QA hours is less than 30 for the last month
of QA (4 point average). This was not a must item, but is a desirable
goal.
.LI   
Manufacturing specs documentation has been completed.
.LE
.SP
The RCS system on HP-UX was used for source code control throughout the
project, and the DTS system was used for defect tracking. We feel that
use of these tools has lowered the incidence of "lost" source or fixes,
and our ability to relate source changes and specific defects has
been enhanced.
.SP
The overall reliability of the system should be similar to that of 
previous PWS releases -- very good. However, the large amount of
new code associated with HFS will probably lead to an increase in
the number of reported defects in the short term. 
.SP
Graphs summarizing the QA statistics are attached.
.H 1 "PERFORMANCE"
The performance of the 3.2 release is covered in a separate memo filed
with this report.
.H 1 "SUPPORTABILITY"
Supportability of the 3.2 release should be similar to that of previous
PWS releases. The field has considerable experience with the product,
and major problems are not expected. A caution is appropriate here, since
the number of SE's trained in the internals of the system has been
decreasing, and support of internal OS features is becoming more difficult.
In addition, many of the factory support PWS experts have been moved to
new assignments, and the current support staff is likely to require 
more help from the R & D team than in the past.
  


