.ce
.ul
MC68030 and MC 68882 ERS
.SP
.SP
PAWS 3.21 has put support of the 68030 processor and the 68882 math 
coprocessor as a high want. 
.SP
The main new features or differences of the 68030 from the 68020
that we can currently identify are:
.SP
.ML o
.LI
Has an internal data cache (d-cache) in addition to the internal instruction 
cache (i-cache) that is already on the 68020. Use of this cache has the 
potential to speed up PAWS general operation by 10 to 30%. Using this 
cache presents a couple of minor problems. It needs to be disabled for 
accesses to addresses in
I/O space, and it needs to be flushed when the transition is made between
user and supervisor mode (interrupt handling).
.SP
.LI
Will run at >= 30 MHz clock rate. This should present no problems, as for 3.2
we cleaned out the last software timing loops in the system.
.LE
.SP
.SP
The main differences between the 68881 and the 68882 are that the '882 is faster
and that it can produce a new, yet larger stack frame that needs to be cleaned
up by the OS.
.SP
.SP
Should we support these 2 new chips, support will look like this:
.SP
.ML o
.LI
The hardware will run with both i-cache and d-cache enabled. This is expected
to increase execution speed by up to 30% over the 68020 implementations at
similar clock speed. Clock speed is expected to be faster also.
.LI
Both COMPILER and COMPILE20 generated object code will be compatible with 
these devices, so user applications from 3.2 will run on a 68030/68882 
machine with no changes.
.LI
The OS will have some minor mods to allow interrupts, etc to be handled 
correctly when the 68882 is busy, or the d-cache needs flushing.
.LI
The OS will not contain any code which requires either the 68030 or the
68882, except an optimized DGL library which will also work with the 68020
and 68881. 
This library already exists as FGRAPH20, first provided in PAWS 3.12.
.LI
The discs and files provided in the product shipment will not change due to 
support of these devices.
.LE
.bp
