.ND "10 May 1988"
.PH ""
.ce
Pascal 3.21 Test Plan
.SP 3
.ce
Scott Bayes
.br
.ce
John Schmidt
.br
.SP
.ce
HP-UX DCE Lab
.br
.SP
This is the Test Plan for the Pascal 3.21 release. This release adds
support for the 98548A, 98550A, and 319C+ display systems. 
.PH "'Pascal 3.21 Test Plan'\\\\*(DT'\\\\nP'"
.SK
.MT 4
.nr Pi 5
.nr Pt 1
.nr Ej 1
.nr Hb 7
.nr Hs 7
.ds HF 1 1 1 1 1 1 1
.nr Cl 7
.tr ~
.SA 0
.SA 1
.H 1 Introduction
.H 2 "Product description"
.P
Pascal 3.21 is a minor upgrade of the Pascal Workstation software for the
series 200 and series 300 systems.
The primary objective of the system is to 
support the CATSEYE display family (98548A, 319C+, and 98550A).
.H 2 "Schedule"
Our current schedule calls for QA time on Pascal 3.21 to be approximately
0.5 - 1.0 calendar months.
we should be ready to release bits in early to late June 1988.
The exact termination date is dependent on the number and severity of
the defects found, and
progress in completing QA coverage.
.H 1 "Formal QA Entry Criteria"
.P
The following criteria must be met before we will begin the formal QA 
phase of the project:
.AL A 5 1
.LI
Definition freeze. No new features should be added to the system during
the QA phase. Any new features must be approved by the project manager and
must be documented in the manual. 
.LI
Code development complete.
.LI
Test Plan complete
.LI
ERS complete.
.LI
PERT chart for the remainder of the project
.LI
First QA version of the code
.LE


.H 1 "Exit Criteria"
.P
The following criteria must be satisfied in order to terminate the formal QA
process:
.AL A 5 1
.LI
No serious (weight 5 or more) new defects found in the week 
preceding the end of QA.
.LI
Test suites have been run as described in the plan.
.LI
Coverage testing completed. All areas of the system which have been
modified since the 3.2 release have been tested.
.LI
Manufacturing specs documentation has been completed.
.LI
Final testing has been performed using final versions of all hardware 
which will be mentioned in user manuals. 
.LI
Review of first draft manuals has been completed.
.LE

.H 1 "Resources"
.AL A 5 1
.LI
Project personnel 
.sp
The following personnel are available for QA on Pascal 3.21:
.TS
box;
c| c
l| l.
Name	Primary Responsibilities
_
John Schmidt	T{
QA tracking
T}
_
Scott Bayes	T{
CRT and graphics drivers, integration 
T}
.TE

.LI
B. Early Bird and other QA Sites 
.LE
.P
A pre-QA version of the system has been made available to selected
HP and external software developers.
.P
Subsequent Beta releases will be produced during the QA phase.
.H 1 "Defect Reporting and Control"
.H 2 "Defect Tracking"
.P
Defect tracking will be done using the DTS system. 
Scott Bayes will receive all reports.
.H 2 "Defect report flow."
.P
After submittal, each defect report will be numbered by the
DTS system. The report will be reviewed by the project manager 
and the responsible designer for validity and assignment of weight. 
.P
When a fix is designed, it should be summarized on the report and discussed
with another designer (or the original designer of the code). After the fix
is implemented in a new version of the system, the designer should verify the
fix. If possible, a test program for the bug should be generated and added to
the appropriate test library and if possible the test program should be added
to the DTS defect file. 
.P
If a defect report requests the addition of a feature or a change in the
normal operation of the system, it will be considered to be a design change
request. Design change requests will require the approval of the project
manager.
.H 3 "Source code integrity"
.P
The source code for the system is kept on the HP-UX machine
hpfclw in the directory src/paws/src.
Changes in the source are tracked using RCS.
During the turn process the source code is checked out and
transfered to the Pascal workstation turn system via
LAN.
At the completion of every turn the source code is automatically examined
for changes and updated if necessary.
.H 3 "QA statistics"
.P
The project manager will be responsible for tabulating all necessary 
statistics during the formal QA process. Most necessary reports should
be easily available through the DTS system.
Statistics kept will include:
.AL 1 5 1
.LI
Defect totals and weights (cumulative).
.LI
Test areas covered.
.LE
.SP
Users will be asked to keep time logs of
QA related activities. These logs will be used to aid in
developing models for QA time estimation and in determining what activities
are most useful during the QA process. Logs will be distributed and collected
each time the system is released. 
.H 3 "Source code statistics"
.P
Several reports on both the original and the current system are available
to track the number of changes made since 3.2.
.SK
.H 2 "Defect weighting and classification."
.so weights
.H 1 "Detail Test Plans"
.so catseye.mm
.TC 7 1 7 0
