.H 1 "HFS Test Plan"
.SP
HFS was first implented in PAWS in the 3.2 revision. Since that time, HFS 
on HP-UX has changed somewhat. This plan is aimed at testing for PAWS HFS
continued compatibility with HP-UX and RMB HFS.
.SP
.H 2 "Overview"
.SP
Areas that have changed in HP-UX's implementation of HFS since PAWS revision
3.2 are:
.AL
.LI
Addition of longfilenames
.LI
Addition of Access Control Lists (ACLs)
.LI
Addition of Context Dependent Files (CDFs)
.LE
.SP
See the "HFS" section of the 3.22 ERS for details on how each of these is
expected to be handled in revision 3.22.
.SP
.H 2 "Testing"
.SP
We will test longfilenames HFS handling by booting up a PAWS system
connected to a longfilename HFS from HP-UX revision 6.2. If PAWS refuses
to recognize the HFS, it will have passed the test. We will also boot
PAWS connected to a "short" filenames HFS from HP-UX; if that is recognized
and files can be read and written corretly, directories created, etc.,
it will have completed the test.
.SP
To test ACL compatibility,
we will mount a PAWS-created HFS on an HP-UX 6.5 system, and run this
operation on the disk from the shell, as both root and as another user not
in the "ws" group:
.SP
.nf
>cd /PAWSmountdir; 
>find . -print | {
>while read i
>do
>cat $i > /dev/null
>done }
.fi
.SP
in order to force access on all the PAWS files. If all files are accessed
or refused permission
in accordance with the HP-UX "base" permissions, with no panics, the test
will have been passed.
.SP
CDFs will be tested by creating a text file in PAWS under a CDF directory, and
testing under HP-UX that it is readable according to its permissions and
the HP-UX user/group IDs.
