.PH ""
.ce
Performance Report
.ce
Revision 3.23 of the Pascal Workstation
.ce
David Willis
.ce
May 17, 1990
.SP
.H 1 "Summary"
.P
Revision 3.23 of the Pascal Workstation (PWS) adds support of the
345 and 375 SPUs, SCSI discs, and the PARALLEL I/O port.
Any increased
performance of the operating system is due to the
improved performance of the hardware as this release does not
change the way code is generated or the way the operating system
works.
.P
Our tests indicate that for Dhrystones per second, PWS on the 375 SPU
is 44% faster than on the 370 SPU and 100% faster than on the 360 SPU.
This supports the general contention by HP that the 375 is twice
as fast as the 360.
.P
The Wirth tests, which is a general set of tests that measure
loop timing, real math, array operations, procedure calls, and
linked list/memory management performance indicate a 26% performance
increase for the 375 over the 370 and a 62% performance increase
for the 375 over the 360.
.P
SCSI disc operations as compared with an identical HPIB disc show anywhere
from a 39% to a 48% improvement in performance.  These tests simulate
real operating system access conditions, forcing small 256 and 512
byte disc accesses.
.P
The PARALLEL I/O bus runs at maximal obtainable bandwidth of
about 300Kbytes per second using the transfer operations for both
DMA or FHS access.
.P
.H 1 "Benchmark Results"
.P
The benchmarking undertaken is not intended for publication outside HP.
The benchmarks used are rather simplistic, but are appropriate when
considering the importance of performance placed on PWS by its customers
(compared with HP-UX customers, PWS customers are complacent).
The benchmark programs are:
.P	
.AL
.LI
dhry - the dhrystone benchmark, as implemented by Siemens AG and
loaned to HP.
.LI
wirth - a catchall program that does a little of everything, loop
timing, real math, array operations, procedure calls, and linked
list/memory management tasks. Also from Siemens AG.
.LI
three TM benchmarks creatively called Test03, Test04, and Test05 -
written by Jeff Hendershot which simulate real operating system
usage of disc transfer methods.
.LE
.P
.H 2 "Dhrystone Benchmarks"
.P
The dhrystone benchmark program was run against the 375, 370, 360 and 332.
As expected, the 370, 360, and 332 numbers did not deviate from
the 3.22 benchmarking.
.P
.DS
.ul
     375      370      360       332

    13157.9   9090.9   6578.9    4366.8

    (the units are Dhrystones per Second)

To obtain a relative performance increase, the following formula
was used:

	x% = 1 - 375time/3xxtime

The 375 vs the 370 yields

	13157.9/9090.9 - 1 = 44% increase in performance.

The 375 vs the 360 yields

	13157.9/6578.9 - 1 = 100% increase in performance.

The 375 vs the 332 yields

	13157.9/4366.8 - 1 = 201% increase in performance.
.DE
.P
.H 2 "Wirth Benchmarks"
The wirth benchmark program was run against the 375, 370, 360, and 332.
As expected, the 370, 360, and 332 numbers did not deviate from
the 3.22 benchmarking.
.P
.DS

     Test     375      370      360       332
    ______   _____    _____    _____     _____

      A        8       12        16        24
      B       11       16        21        31
      C        8       12        16        23
      D       49       74        98       147
      E       42       55        68       100
      F       25       31        41        60
      G       36       50        72       104
      H       56       79       109       161
      I       10       14        20        29
      J       13       18        24        36
      K      126      133       208       289
      L      146      156       223       379
      M      222      309       297       442
      N       33       35        63        92
            _____     ____     _____     _____  
    Total    785      994      1276      1917

    (The units are elapse time in centiseconds)

To obtain a relative performance increase, the following formula
was used:

	x% = 1 - 3xxtime/375time

NOTE: that because a small number is an increase, the ratio is
inverted.

The 375 vs the 370 yields

	994/785 - 1 = 26% increase in performance.

The 375 vs the 360 yields

	1276/785 - 1 = 62% increase in performance.

The 375 vs the 332 yields

	1917/785 - 1 = 144% increase in performance.

.DE
.P
.H 2 "SCSI Benchmarks"
.P
The SCSI Benchmarks were obtained using a 370 with a 7958 for
HPIB testing and a 7958S for SCSI testing.
Here are the results:
.DS

                           Test03    Test04    Test05 
                          ________  ________  ________

     HP-IB High Speed       1719      2019      2005
     SCSI High Speed        1230      1365      1348

     HP-IB Low Speed        1729      2019      2007
     SCSI Low Speed         1228      1364      1348

.DE
.P
By computing the performance increase using the same formula as
the Wirth tests (HPIBtime/SCSItime - 1), it becomes apparent that
the SCSI driver and disc is operating at least 40% faster than the
HPIB driver and disc.  This number becomes even more significant
when one considers that the majority of the HPIB driver is written
in ASSEMBLER while the SCSI driver is mainly written in PASCAL.
.P
.H 2 "PARALLEL I/O driver"
.P
Specific tests were not developed to benchmark the PARALLEL driver,
as there was nothing to compare it to.  However, using a counter in
the wait loop of the FHS driver, it became readily apparent that the
software driver was far exceeding the capability of the hardware
to transfer data.
It is understood without proof that DMA will drive the hardware at its
maximum capacity.
.P
The maximum bandwidth of the PARALLEL I/O bus is just under 300 kbytes
per second.
.H 1 "Conclusion"
.P
The performance of this revision of PWS on the new SPUs and SCSI
discs is significantly faster than prior product offerings.
The performance of this revision on existing supported products
is unchanged.
