.PH ""
                                  John Schmidt
                                  May 17, 1990
.SP
.ce  
R & D Quality Report for PaWS 3.23 Release
.SP
This report uses the FURPS model to describe the
quality parameters of the Pascal 3.23 release. The
FURPS parameters are: Functionality, Usability,
Reliability, Performance, and Supportability.
.SP
.H 1 "Functionality"
The basic functionality of the PaWS product has not been
significantly changed in this release. New
SPU's are supported (345 and 375), as
well as other new peripherals. Drivers for the SCSI interface  
and the HP Parallel (Centronics) interface have been added
to the system. In addition, a library of procedure calls is
available to allow programmer access to the SCSI interface, facilitating
the construction of customer-written device drivers.
.H 1 "Usability"
Overall usability of the PaWS system has not been changed
from previous releases. Almost all user code which was
compiled under the 3.0, 3.1, 3.2, 3.21, and 3.22 releases
should run with no problems under the 3.23 version of the
system. 
.H 1 "Reliability"
The 3.22 release has met the goals outlined in the test
plan, as listed below:
.AL
.LI
Testing defined by the plan has been completed.
.LI
Parts of the system which have been modified since the
3.22 release have been tested, with particular emphasis on the
new SCSI and HP Parallel drivers.
.LI
All critical or serious code defects found during the QA phase have been
resolved. In addition, all STARS defects outstanding at this time
have been resolved. A total of 27 defects were logged during the QA phase,
with a cumulative weight of 10.9.
.LI
The code is stable and has been in regular use
by the lab team throughout the QA phase. One serious defect was found
in the Parallel driver during the last week of QA. This was repaired
and careful code inspection and regression testing were performed before
bit release to verify the integrity of the fix. 
.LI
Weighted defects per 1000 hours of QA was 13.01.
This is well within our goal of 30. 
.LI
All manuals have been reviewed and revised, and shipped on schedule
to SRDO.
.LI
At this time we are still awaiting completion of a pilot run. This will
be completed before shipment release.
.LI
Manufacturing specs documentation is in progress, and will be completed
before shipment release.
.LE
.SP
The overall reliability of the 3.23 revision is expected to
be similar to previous releases -- very good to excellent.
.H 1 "Performance"
Performance of the 3.22 revision is addressed in a separate
report. Higher performance is possible with this release through support
of the SCSI interface, and additional SPU speed available with the
345 and 375 models. 
.H 1 "Supportability"
Supportability of the 3.23 release should be similar to that
of previous PaWS releases. The field has had considerable
experience with the product, and no major problems
are expected. Factory 
support expertise for the PaWS product is good, but the lab team must
assist on complicated internals issues. 
While the number of SE's in the field trained in system
internals is still low, the factory support team is 
is able to handle most of these questions. One support concern
is that the system internals documentation product has not been updated
for over 3 years due to insufficient resources. The technical support
group and the lab team will be working together to supply updated
internals information to those customers for whom it is
a requirement. It is likely that the system internals documentation product
will be obsoleted in the near future. 
