.H 1 "I/O Testing"
.P
.H 2 "Overview"
.P
Because this release supports the 362, 382, and 385 SPUs, the I/O
library must be tested to ensure its functionality is still intact.
There have not been any modifications to the I/O library or support
software.
.H 3 "Code Reviews"
.P
A code review is not required. 
.SP
.H 3 "Coverage testings"
.P
There have not been any modifications to the I/O library or 
support software due to defect resolution, therefore coverage
testing is not required.
.H 3 "Test Suites"
.P
An I/O test suite exists for PWS, however enhancments are
required to include RS232. This test suite will be run
on appropriate hardware platforms during the formal QA cycle.
This will make up the I/O testing required for formal QA.
.H 2 "Specific Test Plans"
.P
.H 3 "Criteria"
.BL
.LI
Test new H/W, existing H/W, and S/W to ensure there are no side 
effects in the I/O library and support software from any O/S
modifications.
.LI
After fixing all bugs detected in the full QA test, re-run the full
QA test set during the last week of formal QA.  
For this run,
use only H/W combinations which failed in previous runs, as 
well as any 'suspect' combinations.
.LE
.H 3 "Test Configurations"
.P
The I/O test suite will be run in its entirety against the
following SPUs:
.AL
.LI
385 (33 Mhz 68040 based SPU)
.LI
382 (25 Mhz 68040 based SPU)
.LI
362 (68030 based SPU)
.LE
.P
This matrix tests the new SPUs. This will help ensure that the I/O
library functionality is intact across all SPU platforms.
.H 3 "Estimates"
.P
A complete run of the I/O test suite, including set up time, takes about 
24 hours for 50% planning and 40 hours for 90%.
This number does not include the new RS232 test suite.
.P
To develop the new RS232 test suite, 10 days is required for
50% planning, and 15 days for 90%. Due to resource limitations,
we will not do this for the 3.25 release, but put it off to a
future release, if any.
.DS

This yields:

.ul
             50             90
         0 mts days      0 mts days     RS232 Test Development
        72 mts hours   120 mts hours    Test Suite
         0 mts day       3 mts days     defect repair
	
         9 mts days     18 mts days     TOTAL

.DE
