.H 1 "HP PARALLEL Testing"
.H 2 "Overview"
.P
.P
This release (3.25) adds support for the 362, 382 and 385 SPU's.
The parallel port testing needs to be carried out to ensure that the
parallel driver works with these new SPU's.
.P
.H 3 "Coverage testings"
.SP 
Coverage testing consists of running tests aimed at testing the changes 
on code which has been bugfixed or enhanced, and on related areas where we 
suspect interactions with the change. These tests are independent of existing
test suites. Where practical, the tests will be included in the test suites.
.H 3 "Test Suites"
.SP
This section describes the tests that will
be run for HP Parallel QA.
.P
Tests are required for the following areas:
.BL 5 1
.LI
Standard O/S Printer support
.LI
Standard I/O Programming support for the PARALLEL interface
.LI
Programmer's extensions as described in the 3.23 ERS.
.LE
.P
.H 4 "Standard O/S Printer Support"
.P
Must verify the printer options added to CTABLE, and that
the modifications made to the PRINTER TM work correctly and
do not have side affects for either HP-IB or RS-232 printers.
.P
.H 4 "Standard I/O Programming support for the PARALLEL interface"
.P
Verify the standard I/O routines are supported correctly as defined
in the ERS.
.P
.H 4 "Programmer's extensions as described in the ERS"
.P
Must verify all functionality as defined in the ERS.
Must also verify error handling within the driver.
.P
.H 2 "Specific Test Plans"
.H 3 "Criteria"
.BL
.LI
Test new SPUs (362, 382 and 385) to ensure there are no side 
effects in the PaWS I/O System and support software.
.LI
After fixing all bugs detected in the full QA test, re-run the full
QA test set during the last week of formal QA.  
For this run,
use only H/W combinations which failed in previous runs, as 
well as any 'suspect' combinations.
.LE
.H 3 "Test Configurations"
.P
Correct parallel operation need only be verified on a 385 (33 Mhz
68040 based SPU), 382 (25 Mhz 68040), and a 362 (68030 based) as these
SPUs are the only new SPUs offering support for the HP PARALLEL port.
.P
.H 3 "Estimates"
.DS

.ul
	50		90		Description
	 3 mts days 	 5 mts days 	Text execution
	 0 mts days	 1 mts days	Defect Repair

	 3 mts days	 6 mts days	Total
.DE
