{ STARBASE_ID:sb.p1.h   11/15/85   15:35:27 }
{************************************************************************
 *									*
 *	definitions and types to be included with STARBASE application	*
 *	programs written in Pascal					*
 *									*
 ************************************************************************}
{     (c) Copyright Hewlett-Packard Company, 1985.  
      All rights are reserved.  Copying or other
      reproduction of this program except for archival
      purposes is prohibited without the prior 
      written consent of Hewlett-Packard Company. 
                  
                  
                  RESTRICTED RIGHTS LEGEND
      
      Use, duplication, or disclosure by the Government
      is subject to restrictions as set forth in 
      paragraph (b) (3) (B) of the Rights in Technical
      Data and Computer Software clause in 
      DAR 7-104.9(a).
      
      HEWLETT-PACKARD COMPANY
      Fort Collins, Colorado                              }


const
	{ kinds of graphics devices }
	OUTDEV=0;
	INDEV=1;
	OUTINDEV=2;
	OUTMETA=3;
	INMETA=4;

	{ clear control parameters }
	CLEAR_VDC_EXTENT=1;
	CLEAR_CLIP_RECTANGLE=33;
	CLEAR_DISPLAY_SURFACE=65;

	{ clip control parameters }
	CLIP_TO_RECT=1;
	CLIP_TO_VDC=2;
	CLIP_OFF=3;

	{ gopen open_mode parameter masks }
	SPOOLED=1; { if this bit is on, output is spooled }
	INIT=2; { if this bit is on, device initialization occurs }
	THREE_D=4; {if this bit is on, all transformations are 3D }
	RESET_DEVICE=8; {if this bit is on, hard reset including p1 & p2 }

	{ set p1 p2 units }
	FRACTIONAL=0;
	METRIC=1;
	
	{ mapping modes }
	ISOTROPIC=0;
	DISTORT=1;

	{ Starbase linetypes }
	SOLID=0;
	DASH=1;
	DOT=2;
	DASH_DOT=3;
	DASH_DOT_DOT=4;
	LONG_DASH=5;
	CENTER_DASH=6;
	CENTER_DASH_DASH=7;

	{ polygon interior styles }
	INT_HOLLOW=0;
	INT_SOLID=1;

	{ Matrix concatenation types }
	PRE=0;
	POST=1;
	REPLACE=0;
	PUSH=1;

	{ character switching modes }
	ISO_7BIT=0;
	ISO_8BIT=1;
	HP_8BIT=2;

	{ text precision types }
	STRING_TEXT=0;
	CHARACTER_TEXT=1;
	STROKE_TEXT=2;

	{ text transformation types }
	VDC_TEXT=0;
	WORLD_COORDINATE_TEXT=1;
	TOS_TEXT=2;

	{ text alignment enumerated types }
	TA_LEFT=0;
	TA_CENTER=1;
	TA_RIGHT=2;
	TA_CONTINUOUS_HORIZONTAL=3;
	TA_NORMAL_HORIZONTAL=4;
	
	TA_TOP=0;
	TA_CAP=1;
	TA_HALF=2;
	TA_BASE=3;
	TA_BOTTOM=4;
	TA_CONTINUOUS_VERTICAL=5;
	TA_NORMAL_VERTICAL=6;

	{ character path and line path enumerated types }
	PATH_RIGHT=0;
	PATH_LEFT=1;
	PATH_UP=2;
	PATH_DOWN=3;

	{ input device class enumerated types }
	ALL=0;
	LOCATOR=1;
	CHOICE=4;

	{ event queue states }
	EMPTY_NO_OVERFLOW=0;
	EMPTY_OVERFLOW=1;
	NOT_EMPTY_NO_OVERFLOW=2;
	NOT_EMPTY_OVERFLOW=3;

	{ event message link enumerated types }
	SIMULTANEOUS_EVENT_FOLLOWS=0;
	SINGLE_EVENT=1;

	{ gerr printing flags }
	NO_ERROR_PRINTING=0;
	PRINT_ERRORS=1;
	PRINT_WARNINGS=2;

	{ GLOBAL gescapes }
	SWITCH_SEMAPHORE=0;
	READ_COLOR_MAP=1;
	BLINK_PLANES=2;

	{ GLOBAL raster gescapes }
	R_GET_FRAME_BUFFER=20;
	R_LOCK_DEVICE=21;
	R_UNLOCK_DEVICE=22;
	R_GET_WINDOW_INFO=23;
	R_FULL_FRAME_BUFFER=24;
	R_ALLOC_OFFSCREEN=25;
	R_FREE_OFFSCREEN=26;
	R_BIT_MODE=27;
	R_BIT_MASK=28;
	R_DEF_FILL_PAT=29;

	{ HPGL gescapes }
	HPGL_WRITE_BUFFER=100;
	HPGL_SET_PEN_NUM=101;
	HPGL_SET_PEN_SPEED=102;

	{ HP26XX/HPTERM gescapes }
	HP26_PRINT_ESC=200;
	HPTERM_PRINT_ESC=200;
	HPTERM_640x400=201;

	{ GATOR BOX gescapes }
	GB_NONE=300;

	{ GATORADE gescapes }
	GA_NONE=400;

	{ TOPCAT gescapes }
	TC_HALF_PIXEL=500;

	{ HIL gescapes }
	ENABLE_AUTO_PROMPT=600;
	DISABLE_AUTO_PROMPT=601;
	PROMPT_ON=602;
	PROMPT_OFF=603;
	TRIGGER_ON_RELEASE=604;
	IGNORE_RELEASE=605;

	{ GKSM gescapes }
	GKSM_WRITE_ITEM=700;
	GKSM_GET_ITEM_TYPE=701;
	GKSM_READ_ITEM=702;
	GKSM_SKIP_ITEM=703;
	GKSM_INQ_COLOR_NDCES=704;
	GKSM_INQ_PAT_REP=705;

type
	three_d_point = array [1..3] of real;
	three_d_resolution = array [1..3] of real;
	three_d_limits = array [1..2] of three_d_point;
	two_d_xform = array [1..3,1..2] of real;
	three_d_xform = array [1..4,1..4] of real;
	rgb_color = array [1..3] of real;
	text_extent_array = array [1..12] of real;
	device_model = array [1..20] of char;
	string255 = string[255];
	gescape_arg = record
		case integer of
			0: (i : array[1..64] of integer);
			1: (f : array[1..64] of real);
			2: (c : array[1..255] of char);
		end;
	gbyte = 0..255;
