.H 1 "Resources"
This chapter summarizes the resources needed.
.H 2 "Hardware requirements"
.AL
.LI
1 local disc with several LIF volumes on it
.LI
1 local disc with HFS
.LI
connection to a SRM disc
.LI
access to an HP-UX disc connected to s500
.LI
access to an HP-UX disc connected to s2/300
.LI
1 disc either connected to SRM or local disc with HFS (to do restores)
.LI
connection to a BASIC system?
.LI
floppy disc drive (single/double sided)
.LI
cartridge tape drive
.LI
other BACKUP media?
.LE
.SP
.H 2 "Test environment"
Tests will be done with the three file systems LIF, SRM and HFS.
The WS1.0 will not be specifically tested.
.H 3 "General description"
Here is a general description of how the discs for the test of BACKUP should
look like.
.AL
.LI
LIF
.AL a
.LI
The LIF volumes should contain files of all possible BASIC and PAWS file types.
.LE
.LI
SRM
.AL a
.LI
The SRM disc should contain files of all possible BASIC and PAWS file types.
.LI
There should be several long directory pathes on the disc.
The directories should also contain files in each level.
.LI
Some files and directories should have passwords.
.LI
Some files should have links.
.LE
.LI
HFS
.AL a
.LI
The HFS disc should contain files of all possible file types (WS headers).
There should also be some LIF files which were created by HP-UX.
.LI
There should be several long directory pathes on the disc.
The directories should also contain files in each level.
.LI
Some files should have permissions on them other than the default PAWS mode.
All possible combinations should be present somewhere in the directory tree
that gets backed up.
.LI
Some files should have HP-UX uid and gid other than the default PAWS values.
.P
Here are the users that should be present:
.BL
.LI
root
.LI
paws, basic
.LI
guest
.LE
.P
Here are the groups that should be present:
.BL
.LI
bin
.LI
other
.LI
WS
.LE
.LI
All kinds of device special files have to be on the disc.
Here is a list of them:
.BL
.LI
character special file
.LI
block special file
.LI
fifo file
.LI
network special file
.LE
.LI
Some files should have links.
.LE
.LE
.P
On all three kinds of file systems (LIF, SRM, HFS) files with the following
file types have to be present:
.BL
.LI
Text files
.LI
Ascii files
.LI
Code files
.LI
System files
.LI
BDAT files
.LI
Hp-ux files
.LI
other Data files
.LE
.P
When starting with the tests the state of each disc is not so important
as long as the above criterias are satisfied.
Later on however the disc should have a known and stable state.
The contents of the files on each disc is not relevant.
To make the tests more realistic take a disc which has already been used in
a normal environment.
Check whether each disc meets the above defined criterias and modify the
contents accordingly.
Before the first test is done make a backup (e.g. with TAPEBKUP) of each 
disc, so the tests are reproducible.
.H 3 "Sample directory structure"
For the tests four different directories or volumes are needed on each of
the three file systems.
.AL A
.LI
LIF
.VL 9
.LI "TSTBKP:"
This volume contains all the files for the backup.
.LI "TSTRST:"
This volume is used during restore in rename mode.
It should be empty at the beginning of the tests.
.LI "TSTCPY:"
This volume contains a copy of TSTBKP:.
This copy is never modified.
It is used to regenerate the volume TSTBKP: after an automatic restore
and to check restored files with the original ones.
.LI "TSTLOG:"
This volume contains the log files.
Those files contain the files that are backed up, restored or listed.
They also contain all error messages that occurred during a test.
Those files are only created if the listing output is redirected, in all
other cases this information is only printed onto the CONSOLE:.
.LE
.LI
SRM
.VL 10
.LI "/STSTBKP"
This directory contains the subtree with the files for the backup process.
.LI "/STSTRST"
This directories serves as destination for the restore in rename mode.
It does not contain any files or directories at the beginning of any test.
.LI "/STSTCPY"
This directory contains a copy of the directory subtree /STSTBKP and gets
never modified.
.LI "/STSTLOG"
This directory includes the log files.
.LE
.P
The structure of this tree might look like:
.TS
center;
cssss.
/
|
STSTBKP
|
_
.T&
lcccr.
|	|	|	|	|
WORKSTATIONS	TOOLS	geli	jch	hal
.TE
.P
For the directory structure and files look at an used system and copy
files from there.
.LI
HFS
.VL 10
.LI "/HTSTBKP"
This directory contains the subtree with the files for the backup process.
.LI "/HTSTRST"
This directories serves as destination for the restore in rename mode.
It does not contain any files or directories at the beginning of any test.
.LI "/HTSTCPY"
This directory contains a copy of the directory subtree /HTSTBKP and gets
never modified.
.LI "/HTSTLOG"
This directory includes the log files.
.LE
.P
The structure of this tree might look like:
.TS
center;
cssssss.
/
|
HTSTBKP
|
_
.T&
lcccccr
lcccccr.
|		|	|	|	|	|
dev		users	bin	src	usr	WORKSTATIONS
		|				|
	_	_	_	_		|
.T&
llccrcr.
	|	|	|	|		|
	paws	guest	usera	userb		PWS
.TE
.P
The files and the directory structure underneath each of the directories
described above should be copied from an HP-UX system.
The easiest thing is to create the above shown directory structure with 
HP-UX.
The files under /HTSTBKP/dev can be copied from /dev, this has to be done
similar for /HTSTBKP/bin, /HTSTBKP/src and HTSTBKP/usr.
For the other directories check some of the users directory from HP-UX
and see which one are the most suitable.
.LE
