.H 1 "FILER HFS"

These are the specific tests for the new HFS functionality.
Checking these tests will also perform some of the tests
for the effects of HFS on the other commands.
As a special double check a S300 HP-UX system should be used
to view the files.
.P
All stream test files for the FILER HFS tests will begin with
"sfhfs".
There are 2 possible suffixes, a single letter is for stream files
that setup a particular environment for a test, the two level number
is for a particular test.
The first number represents a specific area and the second number
the sequence number.

.H 2 "Chown Tests"

These tests check the ability to reset the uid of the file
or directory.
The level number is 1.

.H 3 "fhfs.1.1"
Check that legal uids work on files owned by paws (17).
.TS
expand;
l l lw(4.8i).
stream file	:	sfhfs.a & sfhfs.1.1
actions	:	T{
.na
Run the setup stream file first, then the test stream file.
The test stream file should run wihout any problems.
Use the extended listing to check the uids.
Use HP-UX to check the uid values.
.ad
T}
.TE
.H 3 "fhfs.1.2"
Check that illegal uids do NOT work on files owned by paws (17).
.TS
expand;
l l lw(4.8i).
stream file	:	sfhfs.a 
actions	:	T{
.na
Run the setup stream file.
There is no stream file, because this test is supposed to
produce errors.
Try illegal uid numbers.
The error message about legal values should be produced with each
try.
.ad
T}
.TE
.H 3 "fhfs.1.3"
Check that legal uids do NOT work on files NOT owned by paws (17).
.TS
expand;
l l lw(4.8i).
stream file	:	sfhfs.b 
actions	:	T{
.na
Run the setup stream file.
There is no stream file, because this test is supposed to
produce errors.
Try legal uid numbers.
The error message about no permission should be produced.
.ad
T}
.TE

.H 2 "Chgrp Tests"

These tests check the ability to reset the gid of the file
or directory.
The level number is 2.

.H 3 "fhfs.2.1"
Check that legal gids work on files owned by paws (17).
.TS
expand;
l l lw(4.8i).
stream file	:	sfhfs.a & sfhfs.2.1
actions	:	T{
.na
Run the setup stream file first, then the test stream file.
The test stream file should run wihout any problems.
Use the extended listing to check the gids.
Use HP-UX to check the gid values.
.ad
T}
.TE
.H 3 "fhfs.2.2"
Check that illegal gids do NOT work on files owned by paws (17).
.TS
expand;
l l lw(4.8i).
stream file	:	sfhfs.a 
actions	:	T{
.na
Run the setup stream file.
There is no stream file, because this test is supposed to
produce errors.
Try illegal gid numbers.
The error message about legal values should be produced with each
try.
.ad
T}
.TE
.H 3 "fhfs.2.3"
Check that legal gids do NOT work on files NOT owned by paws (17).
.TS
expand;
l l lw(4.8i).
stream file	:	sfhfs.b 
actions	:	T{
.na
Run the setup stream file.
There is no stream file, because this test is supposed to
produce errors.
Try legal gid numbers.
The error message about no permission should be produced.
.ad
T}
.TE

.H 2 "Chmod Tests"

These tests check the ability to reset the mode of the file
or directory.
The level number is 3.

.H 3 "fhfs.3.1"
Check that legal modes work on files owned by paws (17).
.TS
expand;
l l lw(4.8i).
stream file	:	sfhfs.a & sfhfs.3.1
actions	:	T{
.na
Run the setup stream file first, then the test stream file.
The test stream file should run wihout any problems.
Use the extended listing to check the mode.
Use HP-UX to check the mode values.
.ad
T}
.TE
.H 3 "fhfs.3.2"
Check that illegal modes do NOT work on files owned by paws (17).
.TS
expand;
l l lw(4.8i).
stream file	:	sfhfs.a 
actions	:	T{
.na
Run the setup stream file.
There is no stream file, because this test is supposed to
produce errors.
Try illegal mode numbers.
The error message about the range of legal values should 
be produced with each try.
.ad
T}
.TE
.H 3 "fhfs.3.3"
Check that legal modes do NOT work on files NOT owned by paws (17).
.TS
expand;
l l lw(4.8i).
stream file	:	sfhfs.b 
actions	:	T{
.na
Run the setup stream file.
There is no stream file, because this test is supposed to
produce errors.
Try legal mode numbers.
The error message about no permission should be produced.
.ad
T}
.TE

.H 2 "Umask Tests"

These tests check the ability to set and read the umask.
The level number is 4.

.H 3 "fhfs.4.1"
Check that legal umask values work on HFS units.
This means both the input of the value and that files are
created with the correct mode.
.TS
expand;
l l lw(4.8i).
stream file	:	sfhfs.a & sfhfs.4.1
actions	:	T{
.na
Run the setup stream file first, then the test stream file.
The test stream file should run wihout any problems.
Use the extended listing to check the mode of the files and
directories created.
Use HP-UX to check the mode values.
.ad
T}
.TE
.H 3 "fhfs.4.2"
Check that illegal modes do NOT work on HFS units.
.TS
expand;
l l lw(4.8i).
stream file	:	
actions	:	T{
.na
There is no stream file, because this test is supposed to
produce errors.
Try illegal mode numbers.
The error message about legal values should be produced with each
try.
.ad
T}
.TE
.H 3 "fhfs.1.3"
Check that legal modes do NOT work on NON-HFS units.
.TS
expand;
l l lw(4.8i).
stream file	:	
actions	:	T{
.na
There is no stream file, because this test is supposed to
produce errors.
Try legal uid numbers.
The error message about a bad request should be produced.
.ad
T}
.TE

.H 2 "Setup Streams"

The setup stream files will produce a directory structure in which
to run the automatic tests.
This structure will be produced by transforming and copying 
an existing structure to
the test area.
These setup streams will provide some test of other FILER commands
in the HFS environment.
