
.H 1 "Checklist for HFS Configuration Testing"
.P
We assume that the user has a PWS system attached
to the SRM.  It is also possible to copy the
SRM files to a floppy or local disk and use them there.
We also assume that the user is trying to test a particular
disk, which we refer to as "the disk" below.  The disk being
tested will be overwritten, so there should be no
important data on it.
.P
The time for each disk is 1-2 hours.
.P
Here is the procedure for each disk.
.AL
.LI
Boot Pascal from the SRM.
.LI
eXecute *MKHFS on the disk.
.LI
eXecute *HFSCK on the disk.
.LI
eXecute *TABLExxxx, where "xxxx" is whatever extension is
required to get the TABLE appropriate to the booted system.
For example, if you boot 3.2l, you should run *TABLEP32l.
.LI
Stream #5:/USERS/hal/tst/CPYBOOT to put boot files on the disk.
This is a file that copies and installs a system, and also copies
the FILER, EDITOR, and so on.  Its contents are as follows:
.SP
.nf
=D unit number of new disk (e.g., "#11")?
* copy boot files to new disk
ff#5:/SYSTEMS/SYSP32l
@D:/SYSTEM_P
md@D:/WORKSTATIONS
md@D:/WORKSTATIONS/SYSTEM
p@D:/WORKSTATIONS/SYSTEM
f#45:STARTP32l,STARTUP
f#45:TABLEP32l,TABLE
f#45:../SYSTEM42/INITP32l,INITLIB
f#45:EDITOR,$
f#45:COMPILER,$
f#45:FILER,$
f#45:ASSEMBLER,$
f#45:LIBRARIAN,$
f#45:LIBRARY,$
p@D:/
q
x#45:OSINSTALL
i@D:SYSTEM_P
q
**************************************************
* Now boot from the new disk
**************************************************
.fi
.LI
Reboot from the disk.
.LI
Prefix to the root of the new disk.
.LI
eXecute #5:/USERS/hal/tst/TTYPE to test file types.
.P
This is a program that creates files of type TEXT, ASC, UX, and data,
and translates from one type to another, comparing the files to
be sure the translation was successful.
.P
When you run the program, you are asked to enter two parameters:
.BL
.LI
number of lines in file to test
.LI
max number of chars in line (avg will be half of this)
.LE
.SP
Big numbers can cause this test to be very long.
For example, 30,000 lines with a max length of 200 chars takes about 8 hours
on a 9133XV.  For 15-30 minutes, try 3,000 lines with max len 100.
.LI
Stream #5:/USERS/hal/tst/TSTREAM to exercise FILER.
This is a stream file that runs through various 
commands in the FILER.  Its contents are as follows:
.SP
.nf
=D number of disk (e.g., '#11")
* make files to play with
* make files to play with
* make files to play with
* make files to play with
* make files to play with
* make files to play with
fp@D:/
mdFILES
pFILES
mfDAT0.UX
mfDAT1K[1]
mfDAT10K	[19]
mfDAT100K[199]
mfDAT1M[2047]
q
e
qwTXT0
ee
cf#5:/USERS/hal/tst/ONEK
qwTXT1K
ee
cfTXT1K
cfTXT1K
cfTXT1K
cfTXT1K
cfTXT1K
cfTXT1K
cfTXT1K
cfTXT1K
cfTXT1K
cfTXT1K
qwTXT10K
e
e
cfTXT10K
cfTXT10K
cfTXT10K
cfTXT10K
cfTXT10K
cfTXT10K
cfTXT10K
cfTXT10K
cfTXT10K
cfTXT10K
qwTXT100K
e
*e
*cfTXT100K
*cfTXT100K
*cfTXT100K
*cfTXT100K
*cfTXT100K
*cfTXT100K
*cfTXT100K
*cfTXT100K
*cfTXT100K
*cfTXT100K
*qwTXT1M
*e
* Test directory creation at one level:
* Test directory creation at one level:
* Test directory creation at one level:
* Test directory creation at one level:
* Test directory creation at one level:
* Test directory creation at one level:
fp/
mdDIR1
md/DIR2
pDIR2
md../DIR3
p..
md@D:DIR4
pDIR4
md@D:../DIR5
md@D:/DIR6
q
* Test multi-level directory creation:
* Test multi-level directory creation:
* Test multi-level directory creation:
* Test multi-level directory creation:
* Test multi-level directory creation:
* Test multi-level directory creation:
fp/
mdLEV1
md/LEV1/LEV2
pLEV1
md/LEV1/LEV2/LEV3
md../LEV1/LEV2/LEV3/LEV4
p@D:LEV2/LEV3
md../LEV3A
md@D:../LEV3B
p..
p..
mdLEV2A
q
* Test copying and removing files.
* Test copying and removing files.
* Test copying and removing files.
* Test copying and removing files.
* Test copying and removing files.
* Test copying and removing files.
fp@D:/DIR1
f*=,$
r=
f../FILES/=,$
r=
q
* Test listing.
* Test listing.
* Test listing.
* Test listing.
* Test listing.
* Test listing.
fl*
e*/..
l/FILES
e@D:
q
* Test changing names of files and directories.
* Test changing names of files and directories.
* Test changing names of files and directories.
* Test changing names of files and directories.
* Test changing names of files and directories.
* Test changing names of files and directories.
fc/FILES/DAT=,dat=
p/FILES
cdat=,DAT=
c/DIR=,DR=
c/DR=,DIR=
q
* Test translating files.
fp/DIR1
t/FILES/TXT=.TEXT,TXT=
tTXT=,TXT=.UX
tTXT=.UX,TXT=.TEXT
q
* Test linking.
fr=
dd/FILES/=,$
dd=,../DIR2/$
r../DIR2/=
q
* Test moving.
fdm/DIR1/=,/DIR2/$
q
*  Test Krunch, then clean up everything.
fk@D:
p/LEV1/LEV2/LEV3
r=
p..
r=
p..
r=
p..
rDIR1/=
rDIR2/=
rDIR=
rLEV1
rFILES/=
rFILES
q
**********************************************
*
* TSTREAM done
*
**********************************************
.fi
.LI
eXecute #45:HFSCK again to be sure disk still in good shape.
.LE
