			    TESTING MKHFS
			    Hal Prince
			    Sept. 2, 1986


ABSTRACT

	We describe the ways in which MKHFS will be tested.  These tests
fall into three categories.

	First, it will be tested through regular use.

	Second, it will be tested by making file systems on as many
types of disk as possible.  

	Third, it will be tested by giving it unreasonable parameters,
and checking that it properly recovers, as well as by answering 'no'
to the various confirmation requests, and checking that it stops.


RESOURCES NEEDED

	s200/300 running PAWS

	s200/300 running HP-UX (can be same machine that runs PAWS)

	HP disks on which we support HFS under PWS.  These can
	be borrowed, as they are only needed for a few hours each.
	We don't expect to test on ALL of these, but we would like to
	try as many as are available.
	The list:

		788
		7908
		7911
		7912
		7914
		7925
		7933/35
		7945/46
		8290xM 	5.25" floppy
		single-sided micro (e.g. 9122)
		double-sided micro (e.g. 9122)
		9130K	8" floppy (built-in)	
		9133 in all its multiplicities
		9885	8" single-sided floppy
		9895	8" single- or double-sided floppy
		bubble memory


REGULAR USE

	We expect to use MKHFS heavily.  The following activities
and groups can provide test time:

	1) turning the system.

	2) testing other programs.  All HFS programs (BACKUP, the DAM,
	etc) will need HFS file systems.  These should be made with
	MKHFS.

	3) BASIC.  The BASIC group has a copy of MKHFS, and is
	presumably using it or a slightly modified version for
	their own development.


REAL DISKS

	We will test MKHFS on a representative selection of disks.  The tests
will only last at most 1 day per disk, so the disks can be borrowed
from other groups.

	For each disk, we will do the following:

	1) Back up the disk if necessary.

	2) Connect it to PAWS and run TABLE to make the disk accessible.

	3) Run MKHFS on the disk.  See below for more details.

	4) Check the results of MKHFS by running HFSCK under PAWS and
	fsck under HP-UX.

	5) Restore the previous disk contents if necessary.

	The disk created by MKHFS can be checked with HFSCK and fsck, as
we note in step 4.  However, other output of MKHFS, namely the terminal
output, must be checked manually.

	Therefore, each time we run MKHFS, we do the following.

	First, we check that MKHFS describes the device correctly.
If there are several volumes on the same device, they should all be
listed.  If there is any doubt about the correctness of the output,
we can run MEDIAINIT, which gives the same report.

	Second, we examine the default parameters by answering "y"
to the question "Change or examine default parameters?".  We check
that all reported values are correct.  (Note that 913xD/H/L disks
are always listed as 8 sectors per track and 4 tracks per cylinder,
though this does not always match the physical layout of the
disk.  This is done for consistency with HP-UX, and because of
the special way that sectors are spared on these disks.)

	For each disk, we run MKHFS once with the default parameters,
and three times with changed parameters, chosen randomly as follows.  For each
category below, allow a .5 chance of changing the parameter(s) in
that category.  If the category is selected, choose one value or
value combination randomly.

	1) Swap space 1000 (1K blocks), or 10000 on big disks.

	2) Block size/fragment size: 8K/2K, 8K/4K, 8K/8K, 4K/1K, 
	4K/2K, 4K/4K.

	3) Cylinders per group: 32, 8, 4, 2 (some values illegal
	on some disks).

	4) Data bytes per inode: 1024, 1500, 4096, 10000.


UNUSUAL PARAMETERS

	This set of tests never causes a file system to be made.  Instead,
we do the following:

	1) give unreasonable parameters to see how the program recovers

	2) answer "no" to the confirmation requests to ensure that the
	program stops

	These tests need a local disk, but it doesn't matter what kind
it is.
	
	Here is a detailed description of the tests.

	1) Run MKHFS.  Answer 'N' to 'Are you SURE you want
	to proceed?'.

	Expectation: MKHFS stops.

	Run this test again, this time answering 'n' (lower case).

	2) Run MKHFS.  Answer 'Y' to 'Are you SURE you want to proceed?'.
	Answer 'Y' to 'Change or examine default parameters?'.
	Type 'N' to quit without changing the disk. 

	Expectation: MKHFS stops.

	Run this test again, this time answering 'n' (lower case).

	3) Run MKHFS.  Answer 'Y' to 'Change or examine
	default parameters?'.  Change one of the parameters from the
	following list.  Repeat until all values below have been tried.

		Device size 0
		Device size 5
		Swap space bigger than Device size
		Block size 25
		Fragment size 25
		Block size 4K and Fragment size 8K
		Cylinders per group 64
		Cylinders per group 0
		Minimum percent 100
		Data bytes per inode 0
		Data bytes per inode 5

	Expectation: MKHFS will give an error message and die, or
	will correct the bad value and continue after notifying the
	user of the correction.


BOOTING

	The test plan above tests every aspect of MKHFS except one.
The one thing not tested is the LIF volume header that is written
into the first 8K of the device.  The volume header shows no files,
but each (non-existent) file points to the HP-UX booter, also included
in the LIF volume.

	We need to test the correctness of the LIF volume and of the
booter.

	We expect this testing to come automatically as we run PAWS
off HFS on various types of disks.  Therefore, we have no special
tests to exercise this code.


TIME REQUIRED

	Here is an estimate of the time required for each of the above
types of tests.  We estimate both the time to write the test, and the
time to run it.

	Regular Use -- no extra time.

	Real Disks -- 1/2 to 1 day per disk.  Total time depends
	on how many disks we want to test.

	Unusual Parameters -- manual test, so no time for writing.
	1/2 hour to run.

RECORD OF TESTS PERFORMED

	7933
		NOTE -- FSCK won't run on this disk in 1 Mb RAM
		default OK
		cpg 8, dbpi 1024 OK
		swap 10000, b/f 8k/2k, cpg 32, dbpi 1024 OK
		b/f 4k/4k, dbpi 4096 OK
