.H 1 "Real Disks"
We will test MKHFS on a representative selection of disks.  The tests
will only last at most 1 day per disk, so the disks can be borrowed
from other groups.
.P
For each disk, we will do the following:
.AL
.LI
Back up the disk if necessary.
.LI
Connect it to PAWS and run TABLE to make the disk accessible.
.LI
Run MKHFS on the disk.  See below for more details.
.LI
Check the results of MKHFS by running HFSCK under PAWS and
fsck under HP-UX.
.LI
Restore the previous disk contents if necessary.
.LE
.SP
.P
The disk created by MKHFS can be checked with HFSCK and fsck, as
we note in step 4.  However, other output of MKHFS, namely the terminal
output, must be checked manually.
.P
Therefore, each time we run MKHFS, we do the following.
.P
First, we check that MKHFS describes the device correctly.
If there are several volumes on the same device, they should all be
listed.  If there is any doubt about the correctness of the output,
we can run MEDIAINIT, which gives the same report.
.P
Second, we examine the default parameters by answering "y"
to the question "Change or examine default parameters?".  We check
that all reported values are correct.  (Note that 913xD/H/L disks
are always listed as 8 sectors per track and 4 tracks per cylinder,
though this does not always match the physical layout of the
disk.  This is done for consistency with HP-UX, and because of
the special way that sectors are spared on these disks.)
.P
For each disk, we run MKHFS once with the default parameters,
and three times with changed parameters, chosen randomly as follows.  For each
category below, allow a .5 chance of changing the parameter(s) in
that category.  If the category is selected, choose one value or
value combination randomly.
.AL
.LI
Swap space 1000 (1K blocks), or 10000 on big disks.
.LI
Block size/fragment size: 8K/2K, 8K/4K, 8K/8K, 4K/1K, 
4K/2K, 4K/4K.
.LI
Cylinders per group: 32, 8, 4, 2 (some values illegal
on some disks).
.LI
Data bytes per inode: 1024, 1500, 4096, 10000.
.LE
